<?php

/// Delete a thread from admin/

$pathToBlog = "../";

require_once($pathToBlog."admin/access/check_user.php");
checkUser($pathToBlog, "./");

require_once($pathToBlog."utils/entities/url_params.php");
require_once($pathToBlog."utils/entities/post.php");
include($pathToBlog."search/keywords.php");
require_once($pathToBlog."rss_feed/refresh.php");
require_once($pathToBlog."utils/manage_keywords.php");
require_once($pathToBlog."utils/scan_posts.php");

$url = $_POST["url"]; // permalink URL

// update RSS before removing post (to find its infos):
rss_refresh($url, UpdateMode::DELETE, $pathToBlog);

$post = Post::fromFile($pathToBlog.DataUrlParams::fromUrl($url, ObjType::POST)->toUrl(UrlType::FILE));

// decrement keywords:
$keywordsArray = new KeywordsArray($RANKED_KEYWORDS);
$keywordsArray->remove($post->getKeywords());
$keywordsArray->rearrange(SortOrder::ALPHABETIC);
$keywordsArray->toFile($pathToBlog."search/keywords.php");

function rrmdir($dir) {
  if (is_dir($dir)) {
    $objects = scandir($dir);
    foreach ($objects as $object) {
      if ($object != "." && $object != "..") {
        if (filetype($dir."/".$object) == "dir") rrmdir($dir."/".$object);
        else unlink($dir."/".$object);
      }
    }
    rmdir($dir);
  }
}

// remove all files
$postFolder = $pathToBlog.DataUrlParams::fromUrl($url, ObjType::POST)->toUrl(UrlType::FOLDER);
rrmdir($postFolder);

// if now directory is empty, delete it ("recursively"):
$dayDirLength = strlen($postFolder) - 1;
while ($postFolder[$dayDirLength - 1] != '/') $dayDirLength--;
$dayDir = substr($postFolder, 0, $dayDirLength);
if (count(scandir($dayDir)) == 2) { // '.' and '..'
  rmdir($dayDir);
  
  $monthDirLength = $dayDirLength - 1;
  while ($dayDir[$monthDirLength - 1] != '/') $monthDirLength--;
  $monthDir = substr($dayDir, 0, $monthDirLength);
  if (count(scandir($monthDir)) == 2) {  
    rmdir($monthDir);
    
    $yearDirLength = $monthDirLength - 1;
    while ($monthDir[$yearDirLength - 1] != '/') $yearDirLength--;
    $yearDir = substr($monthDir, 0, $yearDirLength);
    if (count(scandir($yearDir)) == 2) {
      rmdir($yearDir);
    }
  }
}

// now, scan posts and return a summary of the (new) last one
$page = $_POST["page"];
$maxPosts = $_POST["maxposts"];
$dataFiles = ScanIndex::getPostsRange(($page-1) * $maxPosts, $maxPosts, $pathToBlog);
if (count($dataFiles) < $maxPosts) exit(); // no more post to show

$lastPost = Post::fromFile($dataFiles[$maxPosts-1]);
$permalink = $lastPost->getPermalink();
$postSummary = "<a href='".$permalink."'>".$lastPost->getTitle()."</a><br/> by <a href='mailto:".$lastPost->getEmail()."'>".$lastPost->getAuthor()."</a> on ".$lastPost->getTime()."<br/>
  <a href='./thread/?url=".$permalink."'><input type='button' value='Show thread' onClick='upsertPost(".$permalink.'")'."'/></a><br/>
  <input type='button' value='Delete thread' onClick='deletePost(\"".$permalink."\",\"".$page."\",\"".$maxPosts."\")'/><hr class='text'/>";
echo $postSummary;

?>
