<?php
$pathToBlog = "../../";

require_once($pathToBlog."admin/access/check_user.php");
checkUser($pathToBlog, "../edit_elements/");

require_once($pathToBlog."utils/parsing/parse_admin.php");
require_once($pathToBlog."utils/text_editor/admin_buttons.php");

// get all relevant HTML elements:
$titleArray = file($pathToBlog."elems/title");
$title = implode("", $titleArray);
$title = ParseAdmin::untransformText($title);

$subtitleArray = file($pathToBlog."elems/subtitle");
$subtitle = implode("", $subtitleArray);
$subtitle = ParseAdmin::untransformText($subtitle);

$menuArray = file($pathToBlog."elems/menu");
$menu = implode("", $menuArray);
$menu = ParseAdmin::untransformText($menu);

$footerArray = file($pathToBlog."elems/footer");
$footer = implode("", $footerArray);
$footer = ParseAdmin::untransformText($footer);
?>

<!DOCTYPE HTML>

<html>

<head>

  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>

  <title>Elements editor</title>
  
  <link href="../style/shared.css" rel="stylesheet" type="text/css"/>
  <link href="../../style/text_editor.css" rel="stylesheet" type="text/css"/>
  <link href="../style/edit_elements.css" rel="stylesheet" type="text/css"/>

  <?php include($pathToBlog."admin/style/variables.js"); ?>
  <script src="../../javas/widths.js" type="text/javascript"></script>
  <script src="../../utils/text_editor/actions.js" type="text/javascript"></script>
  <script src="./index.ajax.js" type="text/javascript"></script>

</head>

<body onLoad="adjustWidths()">

<div id="main">

  <div id="title">
    <span id="mainTitle">Elements editor</span>
  </div>

  <div id="text"> 

    <div id="innerText">

      <div id="editElems">
      
        <form id="editElemsForm" name="editElemsForm" method="post" action="./preview.php" target="target" 
        onsubmit="window.open('', 'target', 'width=600,height=500,left=100,top=100,status=0,menubar=0,toolbar=0')">

          <p>
            Fill at least the main title between markups &lt;title&gt; and &lt;/title&gt;.<br/>
            The other elements: "subtitle", "menu" and "footer" are optional, although a custom menu would be nice.
          </p>

          <div id="editorButtonsContainer">
            <div id="editorButtons">
            <?php showEditorButtons($pathToBlog, "elemsText"); ?>
            </div>
          </div>

          <p>
            <textarea id="elemsText" name="elemsText" cols="70" 
            rows="<?php echo count($titleArray) + count($subtitleArray) + count($menuArray) + count($footerArray) + 19; ?>">&lt;title&gt;
<?php echo $title."\n"; ?>
&lt;/title&gt;

====================

&lt;subtitle&gt;
<?php echo $subtitle."\n"; ?>
&lt;/subtitle&gt;

====================

&lt;menu&gt;
<?php echo $menu."\n"; ?>
&lt;/menu&gt;

====================

&lt;footer&gt;
<?php echo $footer."\n"; ?>
&lt;/footer&gt;
</textarea>
          </p>
          
          <p>
            <label for="hasMathBox">Has math ?</label>
            <input id="hasMathBox" name="hasMathBox" type="checkbox" value="has math"/><br/>
            <label for="hasCodeBox">Has code ?</label>
            <input id="hasCodeBox" name="hasCodeBox" type="checkbox" value="has code"/>
          </p>

          <p>
            <input type="submit" class="actionButton" value="Preview changes"/>
          </p>

        </form>
      
      </div>
        
      <div class="validate" id="validateElems">

        <p>
          <input type="button" class="validateButton" value="Validate changes" onClick="changeElements()"/>
          <input type="button" class="actionButton" value="Reset to defaults" onClick="resetToSample()"/>
        </p>
        
        <p>
          <span id="notifier" class="notifier">Placeholder.</span>
        </p>
        
      </div>

    </div>
    
  </div>
  
  <div id="footer">
  <?php include($pathToBlog."admin/elems/footer"); ?>
  </div>
  
  <div class="clearer"> </div> 

</div>

</body>

</html>
