<?php
$pathToBlog = "../../";

require_once($pathToBlog."admin/access/check_user.php");
checkUser($pathToBlog, "../");

require_once($pathToBlog."utils/entities/post.php");
require_once($pathToBlog."utils/parsing/parse_admin.php");
require_once($pathToBlog."utils/parsing/syntax_highlighter.php"); // always load, in case of

$elemsText = $_POST["elemsText"];

$title = "";
$subtitle = "";
$menu = "";
$footer = "";

$startIndex = 0;
$endIndex = 0;

$startIndex = strpos($elemsText, "<title>");
if ($startIndex >= 0) {
  $endIndex = strpos($elemsText, "</title>", $startIndex);
  $title = substr($elemsText, $startIndex + 7, $endIndex - $startIndex - 7);
}

$startIndex = strpos($elemsText, "<subtitle>");
if ($startIndex >= 0) {
  $endIndex = strpos($elemsText, "</subtitle>", $startIndex);
  $subtitle = substr($elemsText, $startIndex + 10, $endIndex - $startIndex - 10);
}

$startIndex = strpos($elemsText, "<menu>");
if ($startIndex >= 0) {
  $endIndex = strpos($elemsText, "</menu>", $startIndex);
  $menu = substr($elemsText, $startIndex + 6, $endIndex - $startIndex - 6);
}

$startIndex = strpos($elemsText, "<footer>");
if ($startIndex >= 0) {
  $endIndex = strpos($elemsText, "</footer>", $startIndex);
  $footer = substr($elemsText, $startIndex + 8, $endIndex - $startIndex - 8);
}

// get un-parsed elements (with tags like <b>, <i>, ..etc), and parse them
$mainTitle = ParseAdmin::transformText($title);
$subTitle = ParseAdmin::transformText($subtitle);
$menu = ParseAdmin::transformText($menu);
$footer = ParseAdmin::transformText($footer);

$hasMath = isset($_POST["hasMathBox"]);
$hasCode = isset($_POST["hasCodeBox"]);
?>

<!DOCTYPE html>

<html>

<head>

  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>

  <title>Elements preview</title>

  <link href='../style/shared.css' rel='stylesheet' type='text/css'/>
  <link href='../../style/post.css' rel='stylesheet' type='text/css'/>
<?php
if ($hasCode) {
  echo "<link href='../../style/code.css' rel='stylesheet' type='text/css'/>";
}
?>
  
  <?php include($pathToBlog."admin/style/variables.js"); ?>
  <script src="../../javas/widths.js" type="text/javascript"></script>
<?php
if ($hasMath) {
  echo "<script src='http://cdn.mathjax.org/mathjax/latest/MathJax.js?config=TeX-AMS-MML_HTMLorMML' type='text/javascript'></script>";
}
?>

</head>
        
<body onLoad="document.getElementById('menu').style.display='block';adjustWidths()">

<div id="main"> 
  
  <div id="title">
    <span id="mainTitle"><?php echo $mainTitle; ?></span><br/>
    <span id="mainSubtitle"><?php echo $subTitle; ?></span>
  </div>

  <div id="text"> 

    <div id="innerText">
      
      <div id="posts">      
<?php
$post = new Post(0, "some author", "email", "some time", "", "", "post title", "permalink", "post text");
echo $post->toHtml();
?>
      </div>

    </div>

  </div>

  <div id="menu">
    
    <div id="innerMenu">
      
      <div id="menuLinks">
        <?php echo $menu; ?>
      </div>

    </div>
    
  </div>

  <div id="footer">
  <?php echo $footer; ?>
  </div>
 
</div>

</body>

</html>
