<?php
$pathToBlog = "../../";

require_once($pathToBlog."admin/access/check_user.php");
checkUser($pathToBlog, "../edit_settings/");

function isDigit($c) {
  return $c >= '0' && $c <= '9';
}

function getIntConstant($line, $startIndex) {
  $begin = $startIndex;
  while (!isDigit($line[$begin])) $begin++;
  $end = $begin;
  while (isDigit($line[$end])) $end++;
  return intval(substr($line, $begin, $end - $begin));
}

function getStringConstant($line, $startIndex) {
  $begin = $startIndex;
  while ($line[$begin++] != '"') ;
  $end = $begin;
  while ($line[$end] != '"') $end++;
  return substr($line, $begin, $end - $begin);
}

// get all relevant fields:
$blogFile = fopen($pathToBlog."index.php", 'r');
fgets($blogFile); // skip "<?php"
$MAX_POSTS_BLOG = getIntConstant(fgets($blogFile), 23);
$MAX_LAST_POSTS = getIntConstant(fgets($blogFile), 23);
fclose($blogFile);

$adminFile = fopen($pathToBlog."admin/index.php", 'r');
fgets($adminFile); // skip "<?php"
$MAX_POSTS_ADMIN = getIntConstant(fgets($adminFile), 24);
fclose($adminFile);

$rssFile = fopen($pathToBlog."rss_feed/refresh.php", 'r');
fgets($rssFile); // skip "<?php"
$MAX_RSS_ITEMS = getIntConstant(fgets($rssFile), 22);
fclose($rssFile);
?>

<!DOCTYPE HTML>

<html>

<head>

  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>

  <title>Settings editor</title>
  
  <link href="../style/shared.css" rel="stylesheet" type="text/css"/>
  <link href="../style/edit_settings.css" rel="stylesheet" type="text/css"/>
  
  <?php include($pathToBlog."admin/style/variables.js"); ?>
  <script src="../../javas/widths.js" type="text/javascript"></script>
  <script src="./index.ajax.js" type="text/javascript"></script>
  
</head>

<body onLoad="adjustWidths()">

<div id="main">

  <div id="title">
    <span id="mainTitle">Settings editor</span>
  </div>
  
  <div id="text"> 

    <div id="innerText">

      <div id="editSettings">

        <form id="editSettingsForm" name="editSettingsForm">
          
          <p>
            <label for="maxPostsBlog">Max posts to display on blog index (default is 3)</label><br/>
            <input type="text" class="textField" id="maxPostsBlog" name="maxPostsBlog" value="<?php echo $MAX_POSTS_BLOG; ?>"/>
            <br/>
            <label for="maxLastPosts">Max last entries to display in blog index menu column (default is 7)</label><br/>
            <input type="text" class="textField" id="maxLastPosts" name="maxLastPosts" value="<?php echo $MAX_LAST_POSTS; ?>"/>
          </p>
          
          <p>
            <label for="maxPostsAdmin">Max posts to display on admin panel (default is 10)</label><br/>
            <input type="text" class="textField" id="maxPostsAdmin" name="maxPostsAdmin" value="<?php echo $MAX_POSTS_ADMIN; ?>"/>
          </p>
          
          <p>
            <label for="maxRssItems">Max items to store in RSS feed (default is 10)</label><br/>
            <input type="text" class="textField" id="maxRssItems" name="maxRssItems" value="<?php echo $MAX_RSS_ITEMS; ?>"/>
          </p>
          
        </form>

      </div>
      
      <div id="validateSettings" class="validate">
      
        <p>
          <input type="button" class="validateButton" value="Validate changes" onClick="changeSettings()"/>
        </p>

        <p>
          <span id="warner" class="warner">Placeholder.</span>
        </p>
        
        <p>
          <span id="notifier" class="notifier">Placeholder.</span>
        </p>
        
      </div>

    </div>
    
  </div>
  
  <div id="footer">
  <?php include($pathToBlog."admin/elems/footer"); ?>
  </div>
  
  <div class="clearer"> </div> 

</div>

</body>

</html>
