// When removing a post, add a new one (if available) to keep balance
function displayPostSummary(postSummary, permalink) {
  
  var newDiv = document.createElement("div");
  newDiv.setAttribute("class", "postSummary");
  newDiv.setAttribute("id", "post_" + permalink);
  newDiv.innerHTML = postSummary;
  var parent = document.getElementById("posts");
  cleanWhitespace(parent);
  parent.insertBefore(newDiv, document.getElementById("endOfPosts"));
}

// from http://www.webdeveloper.com/forum/showthread.php?t=120202#2
function cleanWhitespace(node) {
  
  var notWhitespace = /\S/;
  for (var x = 0; x < node.childNodes.length; x++) {
    var childNode = node.childNodes[x];
    if ((childNode.nodeType == 3) && (!notWhitespace.test(childNode.nodeValue))) {
      // that is, if it's a whitespace text node
      node.removeChild(node.childNodes[x--]);
    }
    if (childNode.nodeType == 1) {
      // elements can have text child nodes of their own
      cleanWhitespace(childNode);
    }
  }
}

function deleteThread(url, page, maxPosts) {
  
  var xhr = null; 
  if (window.XMLHttpRequest) xhr = new XMLHttpRequest();
  else if (window.ActiveXObject) { // (old) Internet Explorer 
    try {xhr = new ActiveXObject("Msxml2.XMLHTTP");}
    catch (e) {xhr = new ActiveXObject("Microsoft.XMLHTTP");}
  }
  
  if (xhr == null) {
    alert("Your browser does not support AJAX");
    return;
  }
  
  xhr.onreadystatechange = function() {
    if (xhr.readyState == 4 && xhr.status == 200) {
      // we receive the content of next post to show.
      // first, hide old post.
      document.getElementById("post_" + url).style.display = "none";
      // then, display post summary (returned by AJAX)
      if (xhr.responseText.length > 0) {
        displayPostSummary(xhr.responseText, url);
      }
    }
  };

  xhr.open("POST", "./delete_thread.ajax.php", true);    
  xhr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
  xhr.send("url=" + url + "&page=" + page + "&maxposts=" + maxPosts);
}

function deleteUser(author) {
  
  var xhr = getXHR();
  if (xhr == null) {
    alert("Your browser does not support AJAX");
    return;
  }
  
  xhr.onreadystatechange = function() {
    if (xhr.readyState == 4 && xhr.status == 200) {
      // hide corresponding div
      document.getElementById("author_" + author).style.display = "none";
    }
  };
  
  xhr.open("POST", "./delete_user.ajax.php", true);
  xhr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
  xhr.send("author=" + author);
}

function resetBlog() {
  
  // caution: ask the user again, in case of misclick
  var answer = confirm("Are you sure ?\n" +
    "This will erase ALL data, including posts and comments.\n" +
    "You will start over a fresh new blog.")
  if (!answer) return;
  
  var xhr = getXHR();
  if (xhr == null) {
    alert("Your browser does not support AJAX");
    return;
  }
  
  xhr.onreadystatechange = function() {
    if (xhr.readyState == 4 && xhr.status == 200) {
      // just reload (admin) page
      document.location.href = "./";
    }
  };
  
  xhr.open("POST", "./reset_blog.ajax.php", true);
  xhr.send();
}

function logOut() {
  
  var xhr = getXHR();
  if (xhr == null) {
    alert("Your browser does not support AJAX");
    return;
  }
  
  xhr.onreadystatechange = function() {
    if (xhr.readyState == 4 && xhr.status == 200) {
      // logout from admin/ --> relocate to blog
      document.location.href = "../";
    }
  };
  
  xhr.open("HEAD", "./access/logout.ajax.php", true);    
  xhr.send();
}

function getXHR() {
  
  var xhr = null; 
  if (window.XMLHttpRequest) xhr = new XMLHttpRequest();
  else if (window.ActiveXObject) { // (old) Internet Explorer 
    try {xhr = new ActiveXObject("Msxml2.XMLHTTP");}
    catch (e) {xhr = new ActiveXObject("Microsoft.XMLHTTP");}
  }
  return xhr;
}
