<?php
define('MAX_POSTS_ADMIN', 10);
// WARNING: never touch above line

$pathToBlog = "../";

require_once($pathToBlog."admin/access/check_user.php");
$currentUser = checkUser($pathToBlog, "../");

require_once($pathToBlog."utils/entities/comment.php");
require_once($pathToBlog."utils/entities/url_params.php");
require_once($pathToBlog."utils/entities/post.php");
require_once($pathToBlog."utils/scan_posts.php");

$page = 1;
if (isset($_GET["page"])) $page = $_GET["page"];

// all files to print (as titles), sorted
$dataFiles = ScanIndex::getPostsRange(($page-1) * MAX_POSTS_ADMIN, MAX_POSTS_ADMIN, $pathToBlog);
$countFiles = count($dataFiles);
?>

<!DOCTYPE HTML>

<html>

<head>

  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>

  <title>Admin panel</title>
  
  <link href="./style/shared.css" rel="stylesheet" type="text/css"/>
  <link href="./style/index.css" rel="stylesheet" type="text/css"/>
  
  <?php include($pathToBlog."admin/style/variables.js"); ?>
  <script src="../javas/widths.js" type="text/javascript"></script>
  <script src="./index.ajax.js" type="text/javascript"></script>
  
</head>

<body onLoad='document.getElementById("menu").style.display="block";adjustWidths()'>

  <div id='main'> 
    
    <div id="title">
      <span id="mainTitle">Admin panel</span>
    </div>
    
    <div id='text'> 

      <div id='innerText'>
      
        <div id='posts'>
<?php
for ($i=0; $i<$countFiles; $i++) {
  $post = Post::fromFile($dataFiles[$i]);
  $permalink = $post->getPermalink();
  echo "<div class='postSummary' id='post_".$permalink."'><a href='".$pathToBlog.$permalink."'>".$post->getTitle()."</a><br/> by <a href='mailto:".$post->getEmail()."'>".$post->getAuthor()."</a> on ".$post->getTime()."<br/>
  <a href='./thread/?url=".$permalink."'><input type='button' value='Show thread' onClick='upsertPost(\"".$permalink."\")'/></a><br/>
  <input type='button' value='Delete thread' onClick='deleteThread(\"".$permalink."\",\"".$page."\",\"".MAX_POSTS_ADMIN."\")'/><hr class='text'/></div>";
}
?>

          <!-- artificial, to add a post at the end -->
          <div class="clearer" id="endOfPosts"> </div>

        </div>
        
        <div class="navigatePage">
<?php
$nextStartIndex = $page * MAX_POSTS_ADMIN;
echo "<span class='".($page > 1 ? "movePage" : "hiddenMovePage")."'>";
echo "<a href='?page=".($page - 1)."'><-- Prev</a> </span> &nbsp &nbsp\n";
echo "<span class='".(ScanIndex::checkMorePosts($nextStartIndex, $pathToBlog) ? "movePage" : "hiddenMovePage")."'>";
echo "<a href='?page=".($page + 1)."'>Next --></a> </span>\n";
?>
        </div>
        
      </div>
      
    </div>
   
    <div id="menu"> 
      
      <div id="innerMenu">
      
        <div id="menuLinks">
        <?php include($pathToBlog."admin/elems/menu"); ?>
        </div>
        
<?php
if ($currentUser->isRoot()) {
  echo "<div id='users'><p><hr class='hrMenu'/></p><h4>Users list</h4>\n";
  $dir = opendir($pathToBlog."admin/users_infos/");
  while (($file = readdir($dir)) !== FALSE) {
    if ($file[0] == '.') continue;
    $user = User::fromFile($pathToBlog."admin/users_infos/".$file);
    if ($user->isRoot()) continue;
    echo "<div class='user' id='author_".$user->getAuthor()."'>".$user->getAuthor()." : ".$user->getEmail()." - <input type='button' value='Delete' onClick='deleteUser(\"".$user->getAuthor()."\")'/></div>\n";
  }
  echo "<p><a href='./upsert_user/?mode=create'><input type='button' value='Create user'/></a></p>\n";
  echo "</div>";
}
?>

      </div>
      
    </div>

    <div id="footer">
    <?php include($pathToBlog."admin/elems/footer"); ?>
    </div>

    <div class="clearer"> </div> 

  </div>

</body>

</html>
