function applyTheme(pathToTheme, mode) {
  
  var xhr = getXHR();
  if (xhr == null) {
    alert("Your browser does not support AJAX");
    return;
  }
  
  xhr.onreadystatechange = function() {
    if (xhr.readyState == 4 && xhr.status == 200) {
      var notifier = document.getElementById("notifier");
      if (mode=="blog") {
        notifier.innerHTML = "Blog theme updated !";
      }
      else if (mode=="admin") {
        notifier.innerHTML = "Admin theme updated !";
      }
      notifier.style.visibility = "visible";
      window.setTimeout(setNotifierInvisible, 2000);
    }
  };
  
  xhr.open("POST", "./index.ajax.php", true);
  xhr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
  xhr.send("path=" + pathToTheme + "&mode="+mode);
}

var setNotifierInvisible = function() {
  document.getElementById("notifier").style.visibility = "hidden";
}

function deleteTheme(pathToTheme) {
  
  var xhr = getXHR(); 
  if (xhr == null) {
    alert("Your browser does not support AJAX");
    return;
  }
  
  xhr.onreadystatechange = function() {
    if (xhr.readyState == 4 && xhr.status == 200) {
      document.getElementById("theme_" + pathToTheme).style.display = "none";
    }
  };
  
  xhr.open("POST", "./delete.ajax.php", true);
  xhr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
  xhr.send("path=" + pathToTheme);
}

function getXHR() {
  
  var xhr = null;
  if (window.XMLHttpRequest) xhr = new XMLHttpRequest();
  else if (window.ActiveXObject) { // (old) Internet Explorer 
    try {xhr = new ActiveXObject("Msxml2.XMLHTTP");}
    catch (e) {xhr = new ActiveXObject("Microsoft.XMLHTTP");}
  }
  return xhr;
}
