<?php
$pathToBlog = "../../";

require_once($pathToBlog."admin/access/check_user.php");
checkUser($pathToBlog, "../select_theme/");

// get all themes file names:
$pathBlog = "../../style/themes/";
$pathAdmin = "../style/themes/";

$dir = opendir($pathBlog);
$themesBlog = array();
while (($folder = readdir($dir)) !== false) {
  if ($folder[0] != '.') $themesBlog[] = $pathBlog.$folder."/";
}
closedir($dir);
asort($themesBlog); // always display in same order
$countThemesBlog = count($themesBlog);

$dir = opendir($pathAdmin);
$themesAdmin = array();
while (($folder = readdir($dir)) !== false) {
  if ($folder[0] != '.') $themesAdmin[] = $pathAdmin.$folder."/";
}
closedir($dir);
asort($themesAdmin); // always display in same order
$countThemesAdmin = count($themesAdmin);
?>

<!DOCTYPE HTML>

<html>

<head>

  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>

  <title>Theme selector</title>
  
  <link href="../style/shared.css" rel="stylesheet" type="text/css"/>
  <link href="../style/select_theme.css" rel="stylesheet" type="text/css"/>
  
  <?php include($pathToBlog."admin/style/variables.js"); ?>
  <script src="../../javas/widths.js" type="text/javascript"></script>
  <script src="./index.ajax.js" type="text/javascript"></script>

</head>

<body onLoad="adjustWidths()">

<div id="main">

  <div id="title">
    <span id="mainTitle">Theme selector</span>
  </div>
  
  <div id="text"> 

    <div id="innerText">

      <div class="themeBlog">
        <h3>Available blog theme(s)</h3>
      </div>
      
      <div class="themeAdmin">
        <h3>Available admin theme(s)</h3>
      </div>
      
<?php
$i = 0; $j = 0;
while ($i < $countThemesBlog || $j < $countThemesAdmin) {
  
  if ($i < $countThemesBlog) {
    echo "<div id='theme_".$themesBlog[$i]."' class='themeBlog'>\n";
  }
  else {
    echo "<div class='themeBlog'>\n";
  }
  
  $image = $i < $countThemesBlog
    ? $themesBlog[$i]."preview.png"
    : "./blank_preview.png";
  
  echo "<img src='".$image."' alt='theme preview' width='90%'/> <br/>\n";
  
  if ($i < $countThemesBlog) {
    $description = fopen($themesBlog[$i]."DESCRIPTION", 'r');
    echo "<p>\n";
    while ( !feof($description) ) {
      echo fgets($description);
    }
    fclose($description);
    echo "</p>\n";
    
    echo "<input type='button' class='validateButton' value='Select' onClick='applyTheme(\"".$themesBlog[$i]."\",\"blog\")'/>\n";
    echo "<input type='button' class='actionButton' value='Download' onClick='window.open(\"./download.php?pathtotheme=$themesBlog[$i]\",";
      echo "\"\",\"width=600,height=500,left=100,top=100,status=0,menubar=0,toolbar=0\")'/>\n";
    echo "<input type='button' class='actionButton' value='Delete' onClick='deleteTheme(\"".$themesBlog[$i]."\")'/>\n";
  }
  
  echo "</div>\n";
  
  if ($j < $countThemesAdmin) {
    echo "<div id='theme_".$themesAdmin[$j]."' class='themeAdmin'>\n";
  }
  else {
    echo "<div class='themeAdmin'>\n";
  }
  
  $image = $j < $countThemesAdmin
    ? $themesAdmin[$j]."preview.png"
    : "./blank_preview.png";
  
  echo "<img src='".$image."' alt='theme preview' width='90%'/> <br/>\n";
  
  if ($j < $countThemesAdmin) {
    $description = fopen($themesAdmin[$j]."DESCRIPTION", 'r');
    echo "<p>\n";
    while ( !feof($description) ) {
      echo fgets($description);
    }
    fclose($description);
    echo "</p>\n";
    
    echo "<input type='button' class='validateButton' value='Select' onClick='applyTheme(\"".$themesAdmin[$j]."\",\"admin\")'/>\n";
    echo "<input type='button' class='actionButton' value='Download' onClick='window.open(\"./download.php?pathtotheme=$themesAdmin[$j]\",";
      echo "\"\",\"width=600,height=500,left=100,top=100,status=0,menubar=0,toolbar=0\")'/>\n";
    echo "<input type='button' class='actionButton' value='Delete' onClick='deleteTheme(\"".$themesAdmin[$j]."\",\"admin\")'/>\n";
  }
  
  echo "</div>\n";
  
  echo "<div class='clearer'> </div>\n";
  
  $i++; $j++;
}
?>

      <div class='themeBlog'>
        
        <form class="uploadThemeForm" method="post" action="./upload.php" enctype="multipart/form-data" target="target" 
        onsubmit="window.open('', 'target', 'width=600,height=500,left=100,top=100,status=0,menubar=0,toolbar=0')">  
          <label for="themeBlogFile">Upload blog theme</label> <br/>
          <input type="file" id="themeBlogFile" name="themeBlogFile">
          <input type="submit" class="validateButton" value="Send"/>
        </form>

      </div>

      <div class='themeAdmin'>
        
        <form class="uploadThemeForm" method="post" action="./upload.php" enctype="multipart/form-data" target="target" 
        onsubmit="window.open('', 'target', 'width=600,height=500,left=100,top=100,status=0,menubar=0,toolbar=0')">  
          <label for="themeAdminFile">Upload admin theme</label> <br/>
          <input type="file" id="themeAdminFile" name="themeAdminFile">
          <input type="submit" class="validateButton" value="Send"/>
        </form>

      </div>
      
      <div id="notifier" class="notifier">
        Placeholder.
      </div>

    </div>
    
  </div>
  
  <div id="footer">
  <?php include("../elems/footer"); ?>
  </div>
  
  <div class="clearer"> </div> 

</div>

</body>

</html>
