<?php
$pathToBlog = "../../";

require_once($pathToBlog."admin/access/check_user.php");
checkUser($pathToBlog, "../");

if (array_key_exists("themeBlogFile", $_FILES)) {
  // blog theme upload
  $uploadType = "blog";
  $fileField = "themeBlogFile";
}
else if (array_key_exists("themeAdminFile", $_FILES)) {
  // admin theme upload
  $uploadType = "admin";
  $fileField = "themeAdminFile";
}
else {
  // direct access not allowed
  header("Location: ../"); 
}

$message = "Upload succeeded.";

// check for errors
if ($_FILES[$fileField]["error"] > 0) {
  $prefix = "Problem during transfer: ";
  switch ($_FILES[$fileField]["error"]) {
    case UPLOAD_ERR_NO_FILE:
      $suffix = "missing file.";
      break;
    case UPLOAD_ERR_INI_SIZE:
      $suffix = "file is too large for PHP.";
      break;
    case UPLOAD_ERR_PARTIAL:
      $suffix = "file only partially uploaded.";
      break;
    default:
      $suffix = "unknown error occurred...";
  }
  $message = $prefix.$suffix;
}

// file is on the server: process
else {
  
  // a zip archive doesn't necessarily ends with '.zip',
  // and a .zip file can be something else than an archive.
  // however, this check will be enough given the context.
  $fileName = $_FILES[$fileField]["name"];
  if (strrchr($fileName, '.') != ".zip") {
    $message = "Error: wrong archive format.";
  }
  
  // put zip contents at adequate location
  $themeName = strstr($fileName, ".", TRUE);
  $pathToThemes = $uploadType == "blog"
    ? $pathToBlog."style/themes/"
    : $pathToBlog."admin/style/themes/";
  $pathToTheme = $pathToThemes.$themeName."/";
  
  $zip = new ZipArchive();
  if ($zip->open($_FILES[$fileField]["tmp_name"]) === TRUE) {
    $zip->extractTo($pathToTheme);
    // check if a single directory is extracted, or multiple files.
    // in the first case, we need to copy files one level up and remove directory.
    $files = scandir($pathToTheme);
    if (count($files) == 3) { // HACK: 3 because '.', '..' and current theme folder
      $themeFolder = $pathToTheme;
      if ($files[0][0] != '.') $themeFolder .= $files[0];
      else if ($files[1][0] != '.') $themeFolder .= $files[1];
      else $themeFolder .= $files[2]; // in fact this line should be enough (but, in case of...)
      $themeFolder .= "/";
      $files = scandir($themeFolder);
      foreach ($files as $file) {
        
        if ($file[0] != '.') {
          copy($themeFolder.$file, $pathToTheme.$file);
          unlink($themeFolder.$file);
        }
      }
      rmdir($themeFolder);
    }
    $zip->close();
  }
  else $message = "Failure while unzipping archive";
}
?>

<!DOCTYPE html>

<html>

<head>

  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>

  <title>Theme uploader</title>
  
  <style>
  div#notifier {
    text-align: center;
  }
  </style>

</head>

<body>

<div id="notifier">
<?php echo $message; ?>
</div>

</body>

</html>
