<?php
$pathToBlog = "../../";

require_once($pathToBlog."admin/access/check_user.php");
checkUser($pathToBlog, "../../");

require_once($pathToBlog."utils/entities/url_params.php");
require_once($pathToBlog."utils/entities/comment.php");
require_once($pathToBlog."utils/entities/post.php");
require_once($pathToBlog."utils/entities/trackback.php");

// permalink URL:
$url = $_GET["url"];

// get post infos
$post = Post::fromFile($pathToBlog.DataUrlParams::fromUrl($url, ObjType::POST)->toUrl(UrlType::FILE));
$withMath = $post->hasMath();
$withCode = $post->hasCode();

// get comments infos
$dir = opendir($pathToBlog.DataUrlParams::fromUrl($url, ObjType::COMMENT)->toUrl(UrlType::FOLDER));
$comments = array();
while (($file = readdir($dir)) !== FALSE) {
  if ($file[0] != '.') {
    $comment = Comment::fromFile($file);
    $withMath |= $comment->hasMath();
    $withCode |= $comment->hasCode();
    $comments[] = $comment;
  }
}
closedir($dir);

// get trackbacks infos:
$dir = opendir($pathToBlog.DataUrlParams::fromUrl($url, ObjType::TRACKBACK)->toUrl(UrlType::FOLDER));
$trackbacks = array();
while (($file = readdir($dir)) !== FALSE) {
  if ($file[0] != '.') {
    $trackbacks[] = Trackback::fromFile($file);
  }
}
closedir($dir);
?>

<!DOCTYPE HTML>

<html>

<head>

  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>

  <title>Thread editor</title>
  
  <link href='../style/shared.css' rel='stylesheet' type='text/css'/>
  <link href='../style/thread.css' rel='stylesheet' type='text/css'/>
  <link href='../../style/post.css' rel='stylesheet' type='text/css'/>
  <link href='../../style/comment.css' rel='stylesheet' type='text/css'/>
  <link href='../../style/trackback.css' rel='stylesheet' type='text/css'/>
  <link href='../../style/core_text.css' rel='stylesheet' type='text/css'/>
<?php
if ($withCode) {
  echo "<link href='../../style/code.css' rel='stylesheet' type='text/css'/>";
}
?>

  <?php include($pathToBlog."admin/style/variables.js"); ?>
  <script src="../../javas/widths.js" type="text/javascript"></script>
  <script src="../../javas/toggle_menu.js" type="text/javascript"></script>
  <script src="./index.ajax.js" type="text/javascript"></script>
<?php
if ($withMath) {
  echo "<script src='http://cdn.mathjax.org/mathjax/latest/MathJax.js?config=TeX-AMS-MML_HTMLorMML' type='text/javascript'></script>";
}
?>

</head>

<body onLoad="document.getElementById('menu').style.display='block';adjustWidths();document.onkeydown=handleKeys">

<div id="main"> 
  
  <div id="title">
    <span id="mainTitle">Thread editor</span>
  </div>
  
  <div id="text"> 

    <div id="innerText">
    
      <div id="posts">
<?php
// print post:
echo $post->toHtml();
echo "<div class='postButtons'>
<a href='./upsert/?url=".$post->getPermalink()."'><input type='button' value='Edit'/></a>
<input type='button' value='Show infos' onClick='showInfos(\"rank in day\",\"".($post->getId() + 1)."\",\"author\",\"".$post->getAuthor()."\",\"email\",\"".$post->getEmail()."\",\"created on\",\"".$post->getTime()."\",\"last edited on\",\"".$post->getLastedit()."\",\"keywords\",\"".$post->getKeywords()."\",\"title\",\"".$post->getTitle()."\",\"permalink\",\"".$post->getPermalink()."\",\"contains code\",\"".($post->hasCode() ? "TRUE" : "FALSE")."\",\"contains maths\",\"".($post->hasMath() ? "TRUE" : "FALSE")."\")'/>
</div>";
?>
      </div>
      
      <div id="comments">
<?php
// print comments (if any)
if (count($comments) > 0) {
  echo "<h4>Comments</h4>\n";
}
for ($i=0; $i<count($comments); $i++) {
  echo $comments[$i]->toHtml();
  echo "<div class='commentButtons'>
  <input type='button' value='Delete' onClick='deleteComment(\"".$comments[$i]->getId()."\")'/>
  <input type='button' value='Show infos' onClick='showInfos(\"rank in post\",\"".($comments[$i]->getId() + 1)."\",\"author\",\"".$comments[$i]->getAuthor()."\"url\",\"".$comments[$i]->getUrl()."\",\"created on\",\"".$comments[$i]->getTime()."\",\"tracking\",\"".$comments[$i]->getTracking()."\"\"contains code\",\"".($comments[$i]->hasCode() ? "TRUE" : "FALSE")."\",\"contains maths\",\"".($comments[$i]->hasMath() ? "TRUE" : "FALSE")."\")'/>
  </div>";
}
?>
      </div>
      
      <div id="trackbacks">
<?php
// print trackbacks (if any)
if (count($trackbacks) > 0) {
  echo "<h4>Trackbacks</h4>\n";
}
for ($i=0; $i<count($trackbacks); $i++) {
  echo $trackbacks[$i]->toHtml();
  echo "<div class='trackbackButtons'>
  <input type='button' value='Delete' onClick='deleteTrackback(\"".$trackbacks[$i]->getId()."\")'/>
  <input type='button' value='Show infos' onClick='showInfos(\"rank in post\",\"".($trackbacks[$i]->getId() + 1)."\",\"blog_name\"".$trackbacks[$i]->getBlog_Name()."\",\"url\",\"".$trackbacks[$i]->getUrl()."\",\"title\",\"".$trackbacks[$i]->getTitle()."\")'/>
  </div>";
}
?>
      </div>
      
    </div>
    
  </div>

  <div id="menu">
    
    <div id="innerMenu">

      <div id="menuLinks">
        <p>
          Toggle me: 'ctrl+alt+M'
        </p>
        <p>
          <input type="checkbox" id="resizeCheckbox" checked="checked"/>
          <label for="resizeCheckbox">auto</label>
          <input type="button" id="resizeButton" value="resize" onClick="adjustWidths()"/>
        </p>
      </div>

      <hr class="hrMenu"/>
      
      <div id="backToAdmin">
        <a href="../">
          <input type="button" value="Admin panel"/>
        </a>
      </div>

    </div>

  </div>

  <div id="footer">
  <?php include($pathToBlog."admin/elems/footer"); ?>
  </div>

  <div id='clearer'> </div> 

</div>

</body>

</html>
