function upsertPost(guid, url) {
  
  var warner = document.getElementById("warner");
  var form = document.forms.upsertPostForm;
  
  var title = form.postTitle.value;
  if (title.length == 0) {
    warner.innerHTML = "Empty title.";
    warner.style.visibility = "visible";
    return;
  }
  
  var text = form.postText.value;
  if (text.length == 0) {
    warner.innerHTML = "Empty post text.";
    warner.style.visibility = "visible";
    return;
  }
  
  var xhr = null; 
  if (window.XMLHttpRequest) xhr = new XMLHttpRequest();
  else if (window.ActiveXObject) { // (old) Internet Explorer 
    try {xhr = new ActiveXObject("Msxml2.XMLHTTP");}
    catch (e) {xhr = new ActiveXObject("Microsoft.XMLHTTP");}
  }
  
  if (xhr == null) {
    alert("Your browser does not support AJAX");
    return;
  }
  
  xhr.onreadystatechange = function() {
    if (xhr.readyState == 4 && xhr.status == 200) {
      // relocate to admin/thread
      document.location.href = "../?url=" + xhr.responseText; // responseText == permalink
    }
  };
  
  xhr.open("POST", "./index.ajax.php", true);
  xhr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
  
  xhr.send("guid=" + guid +
           ((typeof(url) != 'undefined') ? "&url=" + url : "") +
           "&keywords=" + form.keywords.value + 
           "&title=" + title + 
           "&text=" + text + 
           "&date=" + getLocalTime() + 
           "&withmath=" + (form.hasMathBox.checked ? "true" : "false") +
           "&withcode=" + (form.hasCodeBox.checked ? "true" : "false"));
}

function listFiles(guid) {

  var listFilesDiv = document.getElementById("listFiles");
  if (listFilesDiv.style.display == "block") {
    // just hide the div
    listFilesDiv.style.display = "none";
    return;
  }
  
  var xhr = getXHR();
  if (xhr == null) {
    alert("Your browser does not support AJAX");
    return;
  }
  
  xhr.onreadystatechange = function() {
    if (xhr.readyState == 4 && xhr.status == 200) {
      listFilesDiv.innerHTML = xhr.responseText;
      listFilesDiv.style.display = "block";
    }
  };

  xhr.open("GET", "./list_files.ajax.php?guid="+guid, true);
  xhr.send();
}

function deleteFiles(guid) {
  
  var filesString = "";
  var fileCheckboxes = document.getElementsByClassName("fileCheckbox");
  for (var i=0; i<fileCheckboxes.length; i++) {
    if (fileCheckboxes[i].checked) {
      var fileName = fileCheckboxes[i].id;
      filesString += fileName + "/";
    }
  }
  
  var xhr = getXHR();
  if (xhr == null) {
    alert("Your browser does not support AJAX");
    return;
  }
  
  xhr.onreadystatechange = function() {
    if (xhr.readyState == 4 && xhr.status == 200) {
      for (var i=0; i<fileCheckboxes.length; i++) {
        if (fileCheckboxes[i].checked) {
          var deletedFile = document.getElementById("file_" + fileCheckboxes[i].id);
          deletedFile.style.display = "none";
        }
      }
    }
  };

  xhr.open("POST", "./delete_files.ajax.php", true);
  xhr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
  xhr.send("guid="+guid+"&files="+filesString);
}

function listLinks() {
 
  var listLinksDiv = document.getElementById("listLinks");
  var trackbackExcerpt = document.getElementById("trackbackExcerpt");
  if (listLinksDiv.style.display == "block") {
    // just hide the div's
    listLinksDiv.style.display = "none";
    trackbackExcerpt.style.display = "none";
    return;
  }
  
  var xhr = getXHR();
  if (xhr == null) {
    alert("Your browser does not support AJAX");
    return;
  }
  
  xhr.onreadystatechange = function() {
    if (xhr.readyState == 4 && xhr.status == 200) {
      listLinksDiv.innerHTML = xhr.responseText;
      listLinksDiv.style.display = "block";
      trackbackExcerpt.style.display = "block";
    }
  };

  xhr.open("POST", "./list_links.ajax.php", true);
  xhr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
  xhr.send("text=" + document.getElementById("postText").value);
}

// send a ping request to the selected links
function pingLinks() {
  
  // get excerpt (could be empty)
  var excerpt = document.getElementById("trackbackExcerptText").value;
  
  // all potential pings
  var allLinks = document.getElementByClassName("linkCheckbox");
  
  for (var i=0; i<allLinks.length; i++) {
    if (allLinks[i].checked) {
      pingLink(allLinks[i].id, excerpt);
    }
  }
}

function pingLink(link, excerpt) {

  var xhr = getXHR();
  if (xhr == null) {
    alert("Your browser does not support AJAX");
    return;
  }
  
  xhr.onreadystatechange = function() {
    if (xhr.readyState == 4 && xhr.status == 200) {
      var liElem = document.getElementById("link_" + link);
      liElem.innerHTML = liElem.innerHTML + " : " + xhr.responseText;
    }
  };
  
  var title = document.forms.upsertPostForm.title;
  var url = document.location.href;
  
  xhr.open("POST", "./ping_link.ajax.php", true);
  xhr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
  xhr.send("url="+url+"&title="+title+"&link="+link+"excerpt="+excerpt);
}

function listKeywords(hKeyword) {
  
  var listKeywordsDiv = document.getElementById("listKeywords");
  if (listKeywordsDiv.style.display == "block") {
    // just hide the div
    listKeywordsDiv.style.display = "none";
    return;
  }
  
  var backKeyword = ""; // pointer to previous level of keywords hierarchy
  if (hKeyword.length > 0) {
    var endIndex = hKeyword.lastIndexOf("/");
    if (endIndex < 0) endIndex = 0;
    backKeyword = hKeyword.substring(0, endIndex);
  }
  
  var xhr = getXHR();
  if (xhr == null) {
    alert("Your browser does not support AJAX");
    return;
  }
  
  xhr.onreadystatechange = function() {
    if (xhr.readyState == 4 && xhr.status == 200) {
      listKeywordsDiv.innerHTML = xhr.responseText;
      listKeywordsDiv.style.display = "block";
    }
  };
  
  var params = "?prefix=" + hKeyword + "&backkeyword=" + backKeyword;
  xhr.open("GET", "./list_keywords.ajax.php" + params, true);
  xhr.send();
}

function appendKeyword(hKeyword) {
  var keywordsInput = document.getElementById("keywords");
  keywordsInput.value = keywordsInput.value + 
    (keywordsInput.value.length > 0 ? ", " : "")  + hKeyword;
}

function toggleSelect(className) {
  
  var i;
  var checkboxes = document.getElementsByClassName(className);
  var allSelected = true;
  for (i=0; i<checkboxes.length; i++) {
    if (!checkboxes[i].checked) {
      allSelected = false;
      break;
    }
  }
  
  for (i=0; i<checkboxes.length; i++) {
    checkboxes[i].checked = allSelected ? false : true;
  }
}

function getXHR() {
  
  var xhr = null; 
  if (window.XMLHttpRequest) xhr = new XMLHttpRequest();
  else if (window.ActiveXObject) { // (old) Internet Explorer 
    try {xhr = new ActiveXObject("Msxml2.XMLHTTP");}
    catch (e) {xhr = new ActiveXObject("Microsoft.XMLHTTP");}
  }
  return xhr;
}
