<?php

/// Insert or update a post from admin/thread/upsert/

$pathToBlog = "../../../";

require_once($pathToBlog."admin/access/check_user.php");
$currentUser = checkUser($pathToBlog, "../../");

require_once($pathToBlog."utils/entities/url_params.php");
require_once($pathToBlog."utils/entities/comment.php");
require_once($pathToBlog."utils/entities/post.php");
require_once($pathToBlog."utils/entities/user.php");
require_once($pathToBlog."utils/parsing/parse_admin.php");
include($pathToBlog."search/keywords.php");
require_once($pathToBlog."rss_feed/refresh.php");
require_once($pathToBlog."utils/manage_keywords.php");
require_once($pathToBlog."utils/parsing/syntax_highlighter.php"); // always load, in case of

$keywords = $_POST["keywords"];
$title = $_POST["title"];
$text = ParseAdmin::transformText($_POST["text"]);
$editTime = $_POST["date"];

$withMath = $_POST["withmath"] == "true";
$withCode = $_POST["withcode"] == "true";

$dirUpload = ""; // to be filled
$permalink = ""; // to be filled

$keywordsArray = new KeywordsArray($RANKED_KEYWORDS);

if (isset($_POST["url"])) {
  
  // we get an ID == edit mode
  
  $permalink = $_POST["url"];
  $dirUpload = $pathToBlog.DataUrlParams::fromUrl($permalink, ObjType::UPLOAD)->toUrl(UrlType::FOLDER);
  
  // expand /AUTOPATH/myFile.doc into ./data/2012/12/12/0/u/myFile.doc
  $text = str_replace("/AUTOPATH/", $dirUpload, $text); // TODO: more subtle, look for 'a href='

  $filePost = $pathToBlog.DataUrlParams::fromUrl($permalink, ObjType::POST)->toUrl(UrlType::FILE);
  $oldPost = Post::fromFile($filePost);
  
  // remove old keywords
  $keywordsArray->remove($oldPost->getKeywords());
  
  $post = new Post($oldPost->getId(), $oldPost->getAuthor(), $oldPost->getEmail(), $oldPost->getTime(), 
      $editTime." by ".$currentUser->getAuthor(), $keywords, $title, $permalink, $text, $withCode, $withMath);
  $post->toFile($filePost);
  
  rss_refresh($permalink, UpdateMode::EDIT, $pathToBlog);
}

else {
  
  // create mode
  
  $dataPath = $pathToBlog."data/";
  $year = date('Y');
  if (!file_exists($dataPath.$year)) mkdir($dataPath.$year);
  $month = date('m');
  if (!file_exists($dataPath.$year."/".$month)) mkdir($dataPath.$year."/".$month);
  $day = date('d');
  if (!file_exists($dataPath.$year."/".$month."/".$day)) mkdir($dataPath.$year."/".$month."/".$day);
  
  $threadFolders = opendir($dataPath.$year."/".$month."/".$day);
  $pid = -1;
  // TODO: potential concurrent access issues; next few lines should be atomic.
  while (($threadFolder = readdir($threadFolders)) !== FALSE) {
    if ($threadFolder[0] != '.') $pid = max($pid, intval($threadFolder));
  }
  $pid++;
  $threadFolder = $dataPath.$year."/".$month."/".$day."/".$pid;
  mkdir($threadFolder);
  // -- end of potential concurrent access issue

  // create empty followers directory
  $dirFollowers = $pathToBlog.DataUrlParams::fromUrl($threadFolder, ObjType::FOLLOWER)->toUrl(UrlType::FOLDER);
  mkdir($dirFollowers);
  chmod($dirFollowers, 0700);
  
  // create empty comments directory
  $dirComments = $pathToBlog.DataUrlParams::fromUrl($threadFolder, ObjType::COMMENT)->toUrl(UrlType::FOLDER);
  mkdir($dirComments);
  chmod($dirComments, 0700);
  
  // create empty trackbacks directory
  $dirTrackbacks = $pathToBlog.DataUrlParams::fromUrl($threadFolder, ObjType::TRACKBACK)->toUrl(UrlType::FOLDER);
  mkdir($dirTrackbacks);
  chmod($dirTrackbacks, 0700);
  
  // create empty upload directory
  $dirUpload = $pathToBlog.DataUrlParams::fromUrl($threadFolder, ObjType::UPLOAD)->toUrl(UrlType::FOLDER);
  mkdir($dirUpload);
  chmod($dirUpload, 0755); // read+execute access (must be public !)
  
  // expand /AUTOPATH/myFile.doc into ./data/2012/12/12/0/u/myFile.doc
  $text = str_replace("/AUTOPATH/", $dirUpload, $text); // TODO: more subtle, look for 'a href='
  
  $permalink = ArxivUrlParams::fromUrl($threadFolder)->toUrl();
  $post = new Post($pid, $currentUser->getAuthor(), $currentUser->getEmail(), $editTime, "", $keywords, 
          $title, $permalink, $text, $withCode, $withMath);
  $post->toFile($pathToBlog.DataUrlParams::fromUrl($threadFolder, ObjType::POST)->toUrl(UrlType::FILE));
  
  rss_refresh($permalink, UpdateMode::INSERT, $pathToBlog);
}

echo $permalink; // for AJAX

// get temp files, and move them to upload folder
$guid = $_POST["guid"];
$tmpUploadFolder = $pathToBlog."temp/".$guid;
$tmpUpload = opendir($tmpUploadFolder);
while (($file = readdir($tmpUpload)) !== FALSE) {
  if ($file[0] != '.') {
    copy($tmpUploadFolder.$file, $dirUpload.$file);
    unlink($tmpUploadFolder.$file);
  }
}
closedir($tmpUpload);
rmdir($tmpUploadFolder);

// add keywords
$keywordsArray->insert($keywords);
$keywordsArray->rearrange(SortOrder::ALPHABETIC);
$keywordsArray->toFile($pathToBlog."search/keywords.php");

?>
