<?php
$pathToBlog = "../../../";

require_once($pathToBlog."admin/access/check_user.php");
checkUser($pathToBlog, "../thread/post/upsert.php");

require_once($pathToBlog."utils/entities/comment.php");
require_once($pathToBlog."utils/entities/url_params.php");
require_once($pathToBlog."utils/entities/post.php");
require_once($pathToBlog."utils/text_editor/admin_buttons.php");

// get (data) URL of the post [if edit mode!]
$url = "";
if (isset($_GET['url'])) {
  $url = $_GET['url'];
  $post = Post::fromFile($pathToBlog.DataUrlParams::fromUrl($url, ObjType::POST)->toUrl(UrlType::FILE));
}

$pageTitle = $url != "" ? "Post editor" : "Post creator";

// clean temp/ folder in case of (may contain some abandoned files)
$tempObjects = scandir($pathToBlog."temp/");
foreach ($tempObjects as $object) {
  if ($object != "." && $object != "..") rrmdir($pathToBlog."temp/".$object);
}

// new upload temp folder: global unique identifier
$guid = uniqid();
mkdir($pathToBlog."temp/".$guid);

function rrmdir($dir) {
  if (is_dir($dir)) {
    $objects = scandir($dir);
    foreach ($objects as $object) {
      if ($object != "." && $object != "..") {
        if (filetype($dir."/".$object) == "dir") rrmdir($dir."/".$object);
        else unlink($dir."/".$object);
      }
    }
    rmdir($dir);
  }
}
?>

<!DOCTYPE html>

<html>

<head>

  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>

  <title> <?php echo $pageTitle; ?> </title>
  
  <link href="../../style/shared.css" rel="stylesheet" type="text/css"/>
  <link href="../../style/upsert_post.css" rel="stylesheet" type="text/css"/>
  <link href="../../../style/text_editor.css" rel="stylesheet" type="text/css"/>

  <?php include($pathToBlog."admin/style/variables.js"); ?>
  <script src="../../../javas/widths.js" type="text/javascript"></script>
  <script src="../../../javas/time.js" type="text/javascript"></script>
  <script src="./index.ajax.js" type="text/javascript"></script>
  <script src="../../../utils/text_editor/actions.js" type="text/javascript"></script>
  
</head>

<body onLoad="document.getElementById('menu').style.display='block';adjustWidths()">

<div id="main">

  <div id="title">
    <span id="mainTitle"> <?php echo $pageTitle; ?> </span>
  </div>
  
  <div id="text"> 

    <div id="innerText">

      <div id="upsertPost">

        <form id='upsertPostForm' name='upsertPostForm' method="post" action="./preview.php" target="target" 
        onsubmit="window.open('', 'target', 'width=600,height=500,left=100,top=100,status=0,menubar=0,toolbar=0')">

          <p>
            <label for='keywords'>Keywords (optional)</label><br/>
            <input type='text' id='keywords' name='keywords' <?php if ($url != "") echo "value='".$post->getKeywords()."'"; ?>/>
          </p>
        
          <p>
            <label for='postTitle'>Title (required)</label><br/>
            <input type='text' id='postTitle' name='postTitle' <?php if ($url != "") echo "value='".$post->getTitle()."'"; ?>/>
          </p>

          <p>
            <label for='postText'>Text (required)</label>
          </p>

          <div id="editorButtonsContainer">
            <div id="editorButtons">
              <?php showEditorButtons($pathToBlog, "postText"); ?>
            </div>
          </div>
          
          <p>
            <textarea id="postText" name="postText" cols="50" rows="25"><?php if ($url != "") echo $post->getText(); ?></textarea>
          </p>
          
          <p>
            <label for="hasMathBox">Has math ?</label>
            <input id="hasMathBox" name="hasMathBox" type="checkbox" value="has math"/><br/>
            <label for="hasCodeBox">Has code ?</label>
            <input id="hasCodeBox" name="hasCodeBox" type="checkbox" value="has code"/>
          </p>
          
          <p>
            <input type="submit" class="validateButton" value="Preview"/>
          </p>
          
        </form>
      
      </div>
      
      <div class="validate" id="validatePost">
        
        <p>
          <input type="button" class="validateButton" value="Send" onClick="upsertPost(<?php echo "'$guid'"; if ($url != "") echo ",'$url'"; ?>)"/>
        </p>
        
        <p>
          <span id="warner" class="warner">Placeholder.</span>
        </p>
        
      </div>
      
    </div>
    
  </div>
  
  <div id="menu">
    
    <div id="innerMenu">
      
      <div id="helpers">
        
        <h4>Helpers for post edition.</h4>
        
        <p>
        <form id="uploadFileForm" class="uploadFileForm" method="post" action="./upload_file.php?guid=<?php echo $guid; ?>" 
              enctype="multipart/form-data" target="target" 
              onsubmit="window.open('', 'target', 'width=600,height=500,left=100,top=100,status=0,menubar=0,toolbar=0')">  
          <label for="uploadFile">Upload some file</label> <br/>
          <input type="file" class="actionButton" id="uploadFile" name="uploadFile"/>
          <input type="submit" class="validateButton" value="Send"/>
        </form>
        </p>

        <p>
          <input type="button" class="actionButton" value="Show existing keywords" onClick="listKeywords('')"/><br/>
          <input type="button" class="actionButton" value="Show uploaded files" onClick="listFiles('<?php echo $guid; ?>')"/><br/>
          <input type="button" class="actionButton" value="Show links to ping" onClick="listLinks()"/>
        </p>
        
        <div id="listKeywords">
        </div>
  
        <div id="listFiles">
        </div>
        
        <div id="listLinks">        
        </div>
        
        <div id="trackbackExcerpt">
          <p>
            [optional] Write a short text (less than 255 characters) describing your post entry.
          </p>
          <textarea id="trackbackExcerptText" cols="30" rows="5"></textarea>
        </div>
          
      </div>
      
    </div>
    
  </div>
  
  <div id="footer">
  <?php include($pathToBlog."admin/elems/footer"); ?>
  </div>
  
  <div id="clearer"> </div> 

</div>

</body>

</html>
