<?php

/// Preview a post from admin/thread/post/upsert.php

$pathToBlog = "../../../";

require_once($pathToBlog."admin/access/check_user.php");
$currentUser = checkUser($pathToBlog, "../../");

require_once($pathToBlog."utils/entities/url_params.php");
require_once($pathToBlog."utils/entities/comment.php");
require_once($pathToBlog."utils/entities/post.php");
require_once($pathToBlog."utils/parsing/parse_admin.php");
require_once($pathToBlog."utils/parsing/syntax_highlighter.php"); // always load, in case of

$postTitle = $_POST["postTitle"];
$text = ParseAdmin::transformText($_POST["postText"]);

function toDoubleDigits($number) {
  return $number >= 10 ? $number : "0".$number;
}

$timeArray = localtime(time(), TRUE);
$date = (1900 + $timeArray["tm_year"])."-".toDoubleDigits($timeArray["tm_mon"] + 1)."-".toDoubleDigits($timeArray["tm_mday"])
        ." at "
        .toDoubleDigits($timeArray["tm_hour"]).":".toDoubleDigits($timeArray["tm_min"]).":".toDoubleDigits($timeArray["tm_sec"]);

$hasMath = isset($_POST["hasMathBox"]);
$hasCode = isset($_POST["hasCodeBox"]);

$post = new Post(0, $currentUser->getAuthor(), $currentUser->getEmail(), $date, "", "", $postTitle, "", $text, $hasCode, $hasMath);

$titleArray = file($pathToBlog."elems/title");
$blogTitle = implode("", $titleArray);

$subtitleArray = file($pathToBlog."elems/subtitle");
$blogSubtitle = implode("", $subtitleArray);
?>

<!DOCTYPE HTML>

<html>
  
<head>
  
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
  <meta name="description" content="<?php echo $blogSubtitle; ?>"/>
  <meta name="keywords" content="light, simple, blog, siyen"/>

  <title><?php echo $blogTitle; ?></title>
  
  <link href="../../../style/shared.css" rel="stylesheet" type="text/css"/>
  <link href="../../../style/post.css" rel="stylesheet" type="text/css"/>
  <link href='../../style/core_text.css' rel='stylesheet' type='text/css'/>
<?php
if ($hasCode) {
  echo "<link href='../../../style/code.css' rel='stylesheet' type='text/css'/>\n";
}
?>

  <?php include($pathToBlog."style/variables.js");?>
  <script src="../../../javas/widths.js" type="text/javascript"></script>
  <script src="../../../javas/toggleMenu.js" type="text/javascript"></script>
<?php
if ($hasMath) {
  echo "<script src='http://cdn.mathjax.org/mathjax/latest/MathJax.js?config=TeX-AMS-MML_HTMLorMML' type='text/javascript'></script>";
}
?>

</head>

<body onLoad="document.getElementById('menu').style.display='block';adjustWidths();document.onkeydown=handleKeys">

<div id="main"> 
  
  <div id="title">
    <span id="mainTitle"> <?php echo $blogTitle; ?> </span><br/>
    <span id="mainSubtitle"> <?php echo $blogSubtitle; ?> </span><br/>
  </div>
  
  <div id="text"> 

    <div id="innerText">
    
      <div id="posts">
      <?php echo $post->toHtml(); ?>
      </div>

    </div>
    
  </div>
 
  <div id="menu"> 
    
    <div id="innerMenu">
    
      <div id="menuLinks">
        <p>
        <a href="./rss.xml">RSS</a>
        <a href="./rss.xml">
          <img src="./rss_icon.png" alt="RSS_icon" width="15px"/>
        </a>
        </p>
        <hr class="hrMenu"/>
        <?php include($pathToBlog."elems/menu"); ?>
      </div>
      
    </div>
    
  </div>

  <div id="footer">
  <?php include($pathToBlog."elems/footer"); ?>
  </div>

  <div class="clearer"> </div> 

</div>

</body>

</html>
