<?php
$pathToBlog = "../../../";

require_once($pathToBlog."admin/access/check_user.php");
checkUser($pathToBlog, "../../");

if (!array_key_exists("uploadFile", $_FILES)) {
  // direct access not allowed
  header("Location: ../../"); 
}

// global unique identifier (obtained on upsert.php opening)
$guid = $_GET["guid"];

$message = "Upload succeeded.";

// check for errors
if ($_FILES["uploadFile"]["error"] > 0) {
  $prefix = "Problem during transfer: ";
  switch ($_FILES["uploadFile"]["error"]) {
    case UPLOAD_ERR_NO_FILE:
      $suffix = "missing file.";
      break;
    case UPLOAD_ERR_INI_SIZE:
      $suffix = "file is too large for PHP.";
      break;
    case UPLOAD_ERR_PARTIAL:
      $suffix = "file only partially uploaded.";
      break;
    default:
      $suffix = "unknown error occurred...";
  }
  $message = $prefix.$suffix;
}

// file is on the server: process
else {
  if (move_uploaded_file(
    $_FILES["uploadFile"]["tmp_name"], 
    $pathToBlog."temp/".$guid."/".$_FILES["uploadFile"]["name"]) === FALSE)
  {
    $message = "Error while moving file on server.";
  }
}
?>

<!DOCTYPE html>

<html>

<head>

  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
  
  <title>File uploader</title>
  
  <style>
  div#notifier {
    text-align: center;
  }
  </style>
  
</head>

<body>

<div id="notifier">
<?php echo $message; ?>
</div>

</body>

</html>
