<?php

/// Logic to update or insert an (administrator) user

$pathToBlog = "../../";

require_once($pathToBlog."admin/access/check_user.php");
$actionUser = checkUser($pathToBlog, "../");

require_once($pathToBlog."utils/entities/user.php");

$alteredAuthor = $_POST["author"];
$email = $_POST["email"];
$encrypted1 = $_POST["encrypted1"];
$firstName = $_POST["firstname"]; // no check.. can be empty
$lastName = $_POST["lastname"]; // no check.. can be empty
$secret1 = $_POST["secret1"];
$question = $_POST["question"];

unset($_POST["author"]);
unset($_POST["email"]);
unset($_POST["encrypted1"]);
unset($_POST["firstname"]);
unset($_POST["lastname"]);
unset($_POST["secret1"]);
unset($_POST["question"]);

if (strlen($alteredAuthor) == 0) exit("Empty user name.");
if (!filter_var($email, FILTER_VALIDATE_EMAIL)) exit("Invalid email.");

if ($actionUser->getAuthor() != $alteredAuthor) {
  // early stop if desired name already exists
  $dir = opendir($pathToBlog."admin/users_infos/");
  while (($file = readdir($dir)) !== FALSE) {
    if ($alteredAuthor == $file) exit("User already exists.");
  }
  closedir($dir);
}

// generate salt and set encrypted + secret level 2
$salt = uniqid();
$encrypted2 = sha1($salt.$encrypted1);
$secret2 = sha1($salt.$secret1);

// in case of edit: update cookie:
if ($actionUser->getAuthor() == $alteredAuthor) {
  setcookie("verify", $encrypted2, 0, "/");
}

// (re)generate user file
$user = new User($alteredAuthor, $email, $firstName, $lastName, $salt, $encrypted2, 
        $question, $secret2, $actionUser->isRoot() && $actionUser->getAuthor() == $alteredAuthor);
$user->toFile($pathToBlog."admin/users_infos/".$alteredAuthor);

?>
