function displayComment(commentHTML) {
  
  var newDiv = document.createElement("div");
  newDiv.setAttribute("class", "comment");
  newDiv.innerHTML = commentHTML;
  var parent = document.getElementById("comments");
  cleanWhitespace(parent);
  parent.insertBefore(newDiv, document.getElementById("endOfComments"));
}

// from http://www.webdeveloper.com/forum/showthread.php?t=120202#2
function cleanWhitespace(node) {
  
  var notWhitespace = /\S/;
  for (var x = 0; x < node.childNodes.length; x++) {
    var childNode = node.childNodes[x];
    if ((childNode.nodeType == 3) && (!notWhitespace.test(childNode.nodeValue))) {
      // that is, if it's a whitespace text node
      node.removeChild(node.childNodes[x--]);
    }
    if (childNode.nodeType == 1) {
      // elements can have text child nodes of their own
      cleanWhitespace(childNode);
    }
  }
}

function insertComment(url) {
  
  var form = document.forms.newCommentForm;
  var author = form.author.value;
  var warner = document.getElementById("commentWarner");
  
  // TODO: filter on name ? eg. "start with a letter, then only digit, letters, and -, _"
  if (author.length == 0) {
    warner.innerHTML = "Empty user name.";
    warner.style.visibility = "visible";
    return;
  }
  
  var text = form.commentText.value;
  if (text.length == 0) {
    warner.innerHTML = "Empty comment text.";
    warner.style.visibility = "visible";
    return;
  }
  
  var xhr = null; 
  if (window.XMLHttpRequest) xhr = new XMLHttpRequest();
  else if (window.ActiveXObject) { // (old) Internet Explorer 
    try {xhr = new ActiveXObject("Msxml2.XMLHTTP");}
    catch (e) {xhr = new ActiveXObject("Microsoft.XMLHTTP");}
  }
  
  if (xhr == null) {
    alert("Your browser does not support AJAX");
    return;
  }
  
  xhr.onreadystatechange = function() {
    if(xhr.readyState == 4 && xhr.status == 200) {
      if (xhr.responseText.length > 0) {
        // if comment has code and/or math, just reload page for a proper display
        if (form.hasMathBox.checked  || form.hasCodeBox.checked) {
          document.location.href = "./arxiv.php?id=" + url;
        }
        else {
          warner.style.visibility = "hidden";
          displayComment(xhr.responseText);
        }
      }
      else { // TODO: use responseXML instead
        warner.innerHTML = "Invalid URL.";
        warner.style.visibility = "visible";
      }
    }
  };
  
  xhr.open("POST", "./comment/insert.ajax.php", true);    
  xhr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
  var authorUrl = form.authorUrl.value;
  xhr.send("url=" + url +
           "&author=" + author + 
           (authorUrl.length > 0 ? "&authorurl=" + authorUrl : "") + 
           "&text=" + text + 
           "&ctime=" + getLocalTime() +
           "&withmath=" + (form.hasMathBox.checked ? "true" : "false") +
           "&withcode=" + (form.hasCodeBox.checked ? "true" : "false"));
}
