<?php

/// Insert a comment from permalink

$pathToBlog = "../";

require_once($pathToBlog."utils/entities/url_params.php");
require_once($pathToBlog."utils/entities/comment.php");
require_once($pathToBlog."utils/entities/follower.php");
require_once($pathToBlog."utils/entities/post.php");
require_once($pathToBlog."utils/parsing/parse_public.php");

$authorUrl = "";
if (isset($_POST["authorurl"])) {
  $authorUrl = $_POST["authorurl"];
  if (!filter_var($authorUrl, FILTER_VALIDATE_URL)) exit();
}

$url = $_POST["url"]; // NOTE: url IS permalink
$author = $_POST["author"]; // already checked
$ctime = $_POST["ctime"];
$text = ParsePublic::transformComment($_POST["text"]);

$withMath = $_POST["withmath"] == "true";
$withCode = $_POST["withcode"] == "true";

$dirComment = $pathToBlog.DataUrlParams::fromUrl($url, ObjType::COMMENT)->toUrl(UrlType::FOLDER);
$dir = opendir($dirComment);
// TODO: potential concurrent access issues; next few lines should be atomic.
$cid = -1;
while (($file = readdir($dir)) !== FALSE) {
  if ($file[0] != '.') $cid = max($cid, intval($file));
}
$cid++;
$fileComment = $dirComment.$cid;
touch($fileComment); // somewhat against concurrent commenting

// keep track of connexion informations, in case of there were problems with this user
$footprint = Comment::getConnexionInfos();

$comment = new Comment($cid, $url, $author, $authorUrl, $ctime, $footprint, $text, $withCode, $withMath);
echo $comment->toHtml(); // for AJAX
$comment->toFile($fileComment);

// send an e-mail to every follower
$filePost = $pathToBlog.DataUrlParams::fromUrl($url, ObjType::POST)->toUrl(UrlType::FILE);
$post = Post::fromFile($filePost);
$dirFollowers = $pathToBlog.DataUrlParams::fromUrl($url, ObjType::FOLLOWER)->toUrl(UrlType::FOLDER);
$dir = opendir($dirFollowers);
while (($file = readdir($dir)) !== FALSE) {
  if ($file[0] != '.') {
    $follower = Follower::fromFile($file);
    $trySend = $follower->notify($post->getTitle(), $author, $authorUrl, $ctime, $text, $pathToBlog);
    //if (!$trySend) { ... } // TODO ?!
  }
}

?>
