<?php
/// Preview a comment from permalink

$pathToBlog = "../";

require_once($pathToBlog."utils/entities/comment.php");
require_once($pathToBlog."utils/parsing/parse_public.php");
require_once($pathToBlog."utils/parsing/syntax_highlighter.php"); // always load, in case of

$author = $_POST["author"];
$authorUrl = $_POST["authorUrl"];
$text = ParsePublic::transformComment($_POST["commentText"]);

$hasMath = isset($_POST["hasMathBox"]);
$hasCode = isset($_POST["hasCodeBox"]);

function toDoubleDigits($number) {
  return $number >= 10 ? $number : "0".$number;
}

$timeArray = localtime(time(), TRUE);
$date = (1900 + $timeArray["tm_year"])."-".toDoubleDigits($timeArray["tm_mon"] + 1)."-".toDoubleDigits($timeArray["tm_mday"])
        ." at "
        .toDoubleDigits($timeArray["tm_hour"]).":".toDoubleDigits($timeArray["tm_min"]).":".toDoubleDigits($timeArray["tm_sec"]);

$comment = new Comment(0, "", $author, $authorUrl, $date, "", $text, $hasCode, $hasMath);
?>

<!DOCTYPE HTML>

<html>
  
<head>
  
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>

  <title>Comment preview</title>
  
  <link href="../style/shared.css" rel="stylesheet" type="text/css"/>
  <link href="../style/arxiv.css" rel="stylesheet" type="text/css"/>
  <link href="../style/comment.css" rel="stylesheet" type="text/css"/>
<?php
if ($hasCode) {
  echo "<link href='../style/code.css' rel='stylesheet' type='text/css'/>\n";
}
?>

  <?php include($pathToBlog."style/variables.js");?>
  <script src="../javas/widths.js" type="text/javascript"></script>
<?php
if ($hasMath) {
  echo "<script src='http://cdn.mathjax.org/mathjax/latest/MathJax.js?config=TeX-AMS-MML_HTMLorMML' type='text/javascript'></script>";
}
?>

</head>

<body onLoad="adjustWidths()">

<div id="main"> 
  
  <div id="title">
    <span id="mainTitle">Comment preview</span>
  </div>
  
  <div id="text"> 

    <div id="innerText">
    
      <div id="comments">
      <?php echo $comment->toHtml(); ?>
      </div>

    </div>
    
  </div>
  
  <div id="footer">
  <?php include($pathToBlog."elems/footer"); ?>
  </div>

  <div class="clearer"> </div> 

</div>

</body>

</html>
