<?php
define('MAX_POSTS_BLOG', 3);
define('MAX_LAST_POSTS', 7);
// WARNING: never touch above lines

require_once("./utils/entities/url_params.php");
require_once("./utils/entities/comment.php");
require_once("./utils/entities/post.php");
require_once("./utils/scan_posts.php");
require_once("./search/keywords.php");

$page = 1;
if (isset($_GET["page"])) $page = $_GET["page"];

// get title infos:
$titleArray = file("./elems/title");
$title = implode("", $titleArray);

$subtitleArray = file("./elems/subtitle");
$subtitle = implode("", $subtitleArray);

// parse posts texts for math and.or code
$dataFiles = ScanIndex::getPostsRange(($page-1) * MAX_POSTS_BLOG, MAX_POSTS_BLOG, "./");
$posts = array();
$hasCode = FALSE.
$hasMath = FALSE;
for ($i=0; $i<count($dataFiles); $i++) {
  $post = Post::fromFile($dataFiles[$i]);
  $hasMath |= $post->hasMath();
  $hasCode |= $post->hasCode();
  $posts[] = $post;
}

// also look 'flags' (not very good design here..)
$flags = fopen("./elems/flags", 'r');
$hasCode |= substr(fgets($flags), 0, -1) == "true";
$hasCode |= substr(fgets($flags), 0, -1) == "true";
fclose($flags);
?>

<!DOCTYPE HTML>

<html>
  
<head>
  
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
  <meta name="description" content="<?php echo $subtitle; ?>"/>
  <meta name="keywords" content="light, simple, blog, siyen"/>

  <title><?php echo $title; ?></title>
  
  <link href="./style/shared.css" rel="stylesheet" type="text/css"/>
  <link href="./style/index.css" rel="stylesheet" type="text/css"/>
  <link href='./style/core_text.css' rel='stylesheet' type='text/css'/>
<?php
if ($hasCode) {
  echo "<link href='./style/code.css' rel='stylesheet' type='text/css'/>";
}
?>

  <?php include("./style/variables.js");?>
  <script src="./javas/widths.js" type="text/javascript"></script>
  <script src="./javas/time.js" type="text/javascript"></script>
  <script src="./javas/toggle_menu.js" type="text/javascript"></script>
  <script src="./list_keywords.ajax.js" type="text/javascript"></script>
<?php
if ($hasMath) {
  echo "<script src='http://cdn.mathjax.org/mathjax/latest/MathJax.js?config=TeX-AMS-MML_HTMLorMML' type='text/javascript'></script>";
}
?>

</head>

<body onLoad="document.getElementById('menu').style.display='block';adjustWidths();document.onkeydown=handleKeys;listKeywords('')">

<div id="main">
  
  <div id="title">
    <span id="mainTitle"> <?php echo $title; ?> </span><br/>
    <span id="mainSubtitle"> <?php echo $subtitle; ?> </span>
  </div>
  
  <div id="text"> 

    <div id="innerText">
    
      <div id="posts">
<?php
for ($i=0; $i<count($dataFiles); $i++) {
  // count comments and trackbacks
  $dirComments = "./".DataUrlParams::fromUrl($dataFiles[$i], ObjType::COMMENT)->toUrl(UrlType::FOLDER);
  $countComments = count(scandir($dirComments)) - 2; // HACK: minus 2 for '.' and '..'
  $dirTrackbacks = "./".DataUrlParams::fromUrl($dataFiles[$i], ObjType::TRACKBACK)->toUrl(UrlType::FOLDER);
  $countTrackbacks = count(scandir($dirTrackbacks)) - 2; // HACK: minus 2 for '.' and '..'
  echo $posts[$i]->toHtml($countComments, $countTrackbacks);
}
?>
      </div>

      <div class="navigatePage">        
<?php
$nextStartIndex = $page * MAX_POSTS_BLOG;
echo "<span class='".($page > 1 ? "movePage" : "hiddenMovePage")."'>";
echo "<a href='?page=".($page - 1)."'><-- prev</a></span>&nbsp&nbsp\n";
echo "<span class='".(ScanIndex::checkMorePosts($nextStartIndex, "./") ? "movePage" : "hiddenMovePage")."'>";
echo "<a href='?page=".($page + 1)."'>next --></a></span>";
?>
      </div>
     
    </div>
    
  </div>
 
  <div id="menu"> 
    
    <div id="innerMenu">
    
      <div id="menuLinks">
        <p>
          <a href="./rss_feed/rss.xml">RSS</a>
          <a href="./rss_feed/rss.xml">
            <img src="./rss_feed/icon.png" alt="RSS_icon" width="15px"/>
          </a>
        </p>
        <hr class="hrMenu"/>
        <p>
          Toggle me: 'ctrl+alt+M'
        </p>
        <p>
          <input type="checkbox" id="resizeCheckbox" checked="checked"/>
          <label for="resizeCheckbox">auto</label>
          <input type="button" id="resizeButton" value="resize" onClick="adjustWidths()"/>
        </p>
        <hr class="hrMenu"/>
        <?php include("./elems/menu"); ?>
      </div>
      
      <hr class="hrMenu"/>
      
      <div id="archives">
      
        <h4>Last entries</h4>
        <ol>
<?php
$dataFiles = ScanIndex::getPostsRange(0, MAX_LAST_POSTS, "./");
for ($i=0; $i<count($dataFiles); $i++) {
  $post = Post::fromFile($dataFiles[$i]);
  echo "<li><a href='".$post->getPermalink()."'>".$post->getTitle()."</a></li>\n";
}
?>
        </ol>
      
      </div>
      
      <hr class="hrMenu"/>

      <div id="search">        

        <p>
          <a href="./search/"><input type="button" id="launchSearchText" value="Search"/></a>
        </p>
  
      </div>

      <hr class="hrMenu"/>
      
      <div id="keywordsList">
      </div>
      
      <hr class="hrMenu"/>

      <p>
        <a href="./admin/"/>Admin panel</a>
      </p>
  
    </div>
    
  </div>

  <div id="footer">
  <?php include("./elems/footer"); ?>
  </div>

  <div class="clearer"> </div> 

</div>

</body>

</html>
