// Returns the version of Internet Explorer or a -1 (indicating the use of another browser).
// [from MSDN: http://msdn.microsoft.com/en-us/library/ms537509(v=vs.85).aspx]
function getInternetExplorerVersion() {

  var rv = -1; // Return value assumes failure.
  if (navigator.appName == "Microsoft Internet Explorer") {
    var ua = navigator.userAgent;
    var re = new RegExp("MSIE ([0-9]{1,}[\.0-9]{0,})");
    if (re.exec(ua) != null) rv = parseFloat(RegExp.$1);
  }
  return rv;
}

// Get the current window width -- ~all browsers compatibility
function getWindowWidth() {

  if (window.innerWidth) {
    return window.innerWidth; // many browsers except IE
  }
  
  // Now, IE:
  if (getInternetExplorerVersion() < 8 || document.documentMode == 7) {
    return document.body.offsetWidth;
  }
  return document.documentElement.offsetWidth;
}

// If "fit automatically" box is checked, this function auto-resize
window.onresize = function() {

  var checkBox = document.getElementById("resizeCheckbox");
  if (checkBox == null || checkBox.checked) adjustWidths();
}

// Adjust window contents to its size
function adjustWidths() {

  var i;
  var w = getWindowWidth();
  
  // safety check:
  if (!w || w == 0) w = 1024;
  
  // Remove estimated size (kind of upper bound) of the (usually there) scrollbar on the right:
  w -= 15;
  
  w = Math.min( Math.max(w, 900), 1900 ); // always w in [900, 1900]
  document.getElementById("main").style.width = w + "px";

  var divMenu = document.getElementById("menu");
  var menuDisplayed = divMenu != null && divMenu.style.display == "block";

  // resize main text
  var divText = document.getElementById("text");
  var sidesSize = tml + tmr + tpl + tpr;
  var percentText = menuDisplayed ? 0.71 : 0.99;
  var widthText = Math.floor(percentText * w) - sidesSize;
  divText.style.width = widthText + "px";

  // get all <hr> elems of the right length:
  var hrText = document.getElementsByClassName("hrText");
  for (i=0; i<hrText.length; i++) {
    hrText[i].style.width = (widthText - 15) + "px";
  }
  
  // resize menu column
  if (menuDisplayed) {
    sidesSize = mml + mmr + mpl + mpr + 2 * mbw;
    var widthMenu = Math.floor(0.28999 * w) - sidesSize;
    divMenu.style.width = widthMenu + "px";
    
    // get all <hr> elems of the right length:
    var hrMenu = document.getElementsByClassName("hrMenu");
    for (i=0; i<hrMenu.length; i++) {
      hrMenu[i].style.width = (widthMenu - 15) + "px";
    }
  }
}
