<?php

/// Class to abstract informations about one user

class User {
  
  private $author; // author name used on the blogging platform
  private $email;
  private $firstName;
  private $lastName;
  private $salt;
  private $encrypted2; // sha1(salt.sha1(username%password))
  private $question;
  private $secret2; // sha1(salt.sha1(question%answer))
  
  private $isRoot; // boolean
  
  public function getAuthor() {
    return $this->author;
  }
  public function getEmail() {
    return $this->email;
  }
  public function getFirstName() {
    return $this->firstName;
  }
  public function getLastName() {
    return $this->lastName;
  }
  public function getSalt() {
    return $this->salt;
  }
  public function getEncrypted2() {
    return $this->encrypted2;
  }
  public function getQuestion() {
    return $this->question;
  }
  public function getSecret2() {
    return $this->secret2;
  }
  
  public function isRoot() {
    return $this->isRoot;
  }
  
  // when author/password change
  public function setSalt($salt) {
    $this->salt = $salt;
  }
  public function setEncrypted2($encrypted2) {
    $this->encrypted2 = $encrypted2;
  }
  public function setSecret2($secret2) {
    $this->secret2 = $secret2;
  }
  
  public function __construct(
          $author, $email, $firstName, $lastName, $salt, 
          $encrypted2, $question, $secret2, $isRoot=FALSE) {
    
    $this->author = $author;
    $this->email = $email;
    $this->firstName = $firstName;
    $this->lastName = $lastName;
    $this->salt = $salt;
    $this->encrypted2 = $encrypted2;
    $this->question = $question;
    $this->secret2 = $secret2;
    $this->isRoot = $isRoot;
  }
  
  public function toFile($file) {

    $writer = fopen($file, 'w');
  
    fwrite($writer, $this->author."\n");
    fwrite($writer, $this->email."\n");
    fwrite($writer, $this->firstName."\n");
    fwrite($writer, $this->lastName."\n");
    fwrite($writer, $this->salt."\n");
    fwrite($writer, $this->encrypted2."\n");
    fwrite($writer, $this->question."\n");
    fwrite($writer, $this->secret2."\n");
    fwrite($writer, ($this->isRoot ? "TRUE" : "FALSE")."\n");
    
    fclose($writer);
  }
  
  public static function fromFile($file) {
    
    $reader = fopen($file, 'r');
    
    // warning: an endline character is added
    // at the end of each non-terminal line.
    $author = substr(fgets($reader), 0, -1);
    $email = substr(fgets($reader), 0, -1);
    $firstName = substr(fgets($reader), 0, -1);
    $lastName = substr(fgets($reader), 0, -1);
    $salt = substr(fgets($reader), 0, -1);
    $encrypted2 = substr(fgets($reader), 0, -1);
    $question = substr(fgets($reader), 0, -1);
    $secret2 = substr(fgets($reader), 0, -1);
    $isRoot = substr(fgets($reader), 0, -1) == "TRUE";
    
    fclose($reader);
    
    return new User($author, $email, $firstName, $lastName, $salt, 
            $encrypted2, $question, $secret2, $isRoot);
  }
}

?>
