<?php

/// Posts by index. Usage: blog index, admin/index

class ScanIndex {

  // Iterate through data/ to retrieve $maxPosts posts
  public static function getPostsRange($startIndex, $maxPosts, $pathToBlog) {
  
    $res = array();
    
    $basePath = $pathToBlog."data";
    
    // step 1 == iterate through first level (year ; and sort)
    $dir = opendir($basePath);
    $fdir1 = array();
    $i = 0;
    while (($file = readdir($dir)) !== false) {
      if ($file[0] != '.') $fdir1[$i++] = $file;
    }
    closedir($dir);
    rsort($fdir1, SORT_NUMERIC);
    $countDir1 = count($fdir1);
    
    $countPosts = 0;
    $i = 0;
    while ($i < $countDir1 && $countPosts - $startIndex < $maxPosts) {
      
      // step 2 == iterate through second level (month ; and sort)
      $dir = opendir($basePath."/".$fdir1[$i]);
      $fdir2 = array();
      $j = 0;
      while (($file = readdir($dir)) !== FALSE) { 
        if ($file[0] != '.') $fdir2[$j++] = $file;
      }
      closedir($dir);
      rsort($fdir2, SORT_NUMERIC);
      $countDir2 = count($fdir2);
      
      $j = 0;
      while ($j < $countDir2 && $countPosts - $startIndex < $maxPosts) {
          
        // step 3 == iterate through third level (day ; and sort)
        $dir = opendir($basePath."/".$fdir1[$i]."/".$fdir2[$j]);
        $fdir3 = array();
        $k = 0;
        while (($file = readdir($dir)) !== FALSE) {
          if ($file[0] != '.') $fdir3[$k++] = $file;
        }
        closedir($dir);
        rsort($fdir3, SORT_NUMERIC);
        $countDir3 = count($fdir3);
      
        $k = 0;
        while ($k < $countDir3 && $countPosts - $startIndex < $maxPosts) {
            
          // final step == iterate through post folders
          $dir = opendir($basePath."/".$fdir1[$i]."/".$fdir2[$j]."/".$fdir3[$k]);
          $postFolders = array();
          $m = 0;
          while (($file = readdir($dir)) !== FALSE) {
            if ($file[0] != '.') $postFolders[$m++] = $file;
          }
          closedir($dir);
          rsort($postFolders, SORT_NUMERIC);
          $countFolders = count($postFolders);
          $m = 0;
          
          while ($m < $countFolders && $countPosts - $startIndex < $maxPosts) {
            if ($countPosts >= $startIndex) {
              $res[$countPosts - $startIndex] =
                $basePath."/".$fdir1[$i]."/".$fdir2[$j]."/".$fdir3[$k]."/".$postFolders[$m]."/p";
            }
            $m++;
            $countPosts++;    
          }
          
          $k++;
        }
        $j++;
      }
      $i++;
    }
    return $res;
  }
  
  // Iterate through data/ to check for more posts
  public static function checkMorePosts($startIndex, $pathToBlog) {
  
    $basePath = $pathToBlog."data";
    
    // step 1 == iterate through first level (year)
    $dir = opendir($basePath);
    $fdir1 = array();
    $i = 0;
    while (($file = readdir($dir)) !== FALSE) {
      if ($file[0] != '.') $fdir1[$i++] = $file;
    }
    closedir($dir);
    $countDir1 = count($fdir1);
    
    $countPosts = 0;
    $i = 0;
    // HACK for boundary check (if number of posts divisible by MAX_POSTS and all posts scanned)
    // TODO: simplify this logic (?!)
    $hitBoundary1 = FALSE; $hitBoundary2 = FALSE; $hitBoundary3 = FALSE; $hitBoundaryFile = FALSE;
    while ($i < $countDir1 && $countPosts - $startIndex < 0) {
      
      // step 2 == iterate through second level (month)
      $dir = opendir($basePath."/".$fdir1[$i]);
      $fdir2 = array();
      $j = 0;
      while (($file = readdir($dir)) !== FALSE) { 
        if ($file[0] != '.') $fdir2[$j++] = $file;
      }
      closedir($dir);
      $countDir2 = count($fdir2);
      
      $j = 0;
      while ($j < $countDir2 && $countPosts - $startIndex < 0) {
          
        // step 3 == iterate through third level (day)
        $dir = opendir($basePath."/".$fdir1[$i]."/".$fdir2[$j]);
        $fdir3 = array();
        $k = 0;
        while (($file = readdir($dir)) !== FALSE) {
          if ($file[0] != '.') $fdir3[$k++] = $file;
        }
        closedir($dir);
        $countDir3 = count($fdir3);
      
        // final step == iterate through post folders
        $k = 0;
        while ($k < $countDir3 && $countPosts - $startIndex < 0) {
          $dir = opendir($basePath."/".$fdir1[$i]."/".$fdir2[$j]."/".$fdir3[$k]);
          $countFiles = 0;
          while (($file = readdir($dir)) !== FALSE) {
            if ($file[0] != '.') $countFiles++;  
          }
          closedir($dir);
          
          $m = 0;
          while ($m < $countFiles && $countPosts - $startIndex < 0) {
            $m++;
            $countPosts++;
          }
          
          $hitBoundaryFile = ($m >= $countFiles);
          $k++;
        }
        $hitBoundary3 = ($k >= $countDir3);
        $j++;
      }
      $hitBoundary2 = ($j >= $countDir2);
      $i++;
    }
    if ($i >= $countDir1) $hitBoundary1 = TRUE;
    return $countPosts >= $startIndex && (!$hitBoundary1 || !$hitBoundary2 || !$hitBoundary3 || !$hitBoundaryFile);
  }
}

?>
