<?php

/// restricted compared to admin edit mode: only one font size

function showEditorButtons($pathToBlog, $textAreaId) {
  
  $buttonsGroups = array(
    // basic controls
    array("bold", "italic", "underline", "strike_through", "line_jump", "horizontal_line"),
    
    // format blocks of text
    array("paragraph", "color"),
    
    // lists
    array("list_item", "bulleted_list", "numbered_list"),
    
    // misc, including 'multimedia'
    array("code", "link"));
  
  // text colors
  $colors = array(
    array("#000000", "#444444", "#666666", "#999999", "#cccccc", "#eeeeee", "#f3f3f3", "#ffffff"),
    array("#ff0000", "#ff9900", "#ffff00", "#00ff00", "#00ffff", "#0000ff", "#9900ff", "#ff00ff"),
    array("#f4cccc", "#fce5cd", "#fff2cc", "#d9ead3", "#d0e0e3", "#cfe2f3", "#d9d2e9", "#ead1dc"),
    array("#ea9999", "#f9cb9c", "#ffe599", "#b6d7a8", "#a2c4c9", "#9fc5e8", "#b4a7d6", "#d5a6bd"),
    array("#e06666", "#f6b26b", "#ffd966", "#93c47d", "#76a5af", "#6fa8dc", "#8e7cc3", "#c27ba0"),
    array("#cc0000", "#e69138", "#f1c232", "#6aa84f", "#45818e", "#3d85c6", "#674ea7", "#a64d79"),
    array("#990000", "#b45f06", "#bf9000", "#38761d", "#134f5c", "#0b5394", "#351c75", "#741b47"),
    array("#660000", "#783f04", "#7f6000", "#274e13", "#0c343d", "#073763", "#20124d", "#4c1130"));
  
  foreach ($buttonsGroups as $buttons) {
    echo "<div class='editorButtonsGroup'>\n";
    foreach ($buttons as $button) {
      
      if ($button == "color" || $button == "code") {
        // specials
        echo "<div class='specialButton'>\n";
        echo "<img class='editor_icon' src='".$pathToBlog."utils/text_editor/icons/".$button.".png' ";
        echo "class='editorButton' id='editorButton_title' onClick='toggleEditorChoices(\"$button\")'/>\n";
      }
      else {
        // normal
        echo "<img class='editor_icon' src='".$pathToBlog."utils/text_editor/icons/".$button.".png' ";
        echo "class='editorButton' id='editorButton_title' onClick='formatText(\"$button\",\"$textAreaId\",false)'/>\n";
      }
      
      if ($button == "color") {
        // text color choices (color palette)
        echo "<table id='colorPalette' class='editorChoices'><th></th>\n";
        foreach ($colors as $row) {
          echo "<tr>";
          foreach ($row as $color) {
            echo "<td style='color:$color;background-color:$color' onClick='formatText(\"color\",\"$textAreaId\",false,\"$color\")')>--</td>";
          }
          echo "</tr>\n";
        }
        echo "</table>\n";
        echo "</div>\n";
      }
      
      else if ($button == "code") {
        // code style choices
        echo "<table id='codeStyles' class='editorChoices'><th></th>\n";
        echo "  <tr><td onClick='formatText(\"code\",\"$textAreaId\",false,\"plain\")'>plain</td></tr>\n";
        echo "  <tr><td onClick='formatText(\"code\",\"$textAreaId\",false,\"boxed\")'>boxed</td></tr>\n";
        echo "  <tr><td onClick='formatText(\"code\",\"$textAreaId\",false,\"numline\")'>numline</td></tr>\n";
        echo "  <tr><td onClick='formatText(\"title\",\"$textAreaId\",false,\"boxed_numline\")'>boxed_numline</td></tr>\n";
        echo "</table>\n";
        echo "</div>\n";
      }
    }
    echo "</div>\n";
  }
}

?>
